// THIS FILE IS GENERATED AUTOMATICALLY. DO NOT MODIFY.
import { SigningStargateClient } from '@cosmjs/stargate'
import { Registry } from '@cosmjs/proto-signing'
import { Api } from './rest'
import { MsgConnectionOpenTry } from './types/ibc/core/connection/v1/tx'
import { MsgConnectionOpenConfirm } from './types/ibc/core/connection/v1/tx'
import { MsgConnectionOpenInit } from './types/ibc/core/connection/v1/tx'
import { MsgConnectionOpenAck } from './types/ibc/core/connection/v1/tx'
const types = [
	['/ibc.core.connection.v1.MsgConnectionOpenTry', MsgConnectionOpenTry],
	[
		'/ibc.core.connection.v1.MsgConnectionOpenConfirm',
		MsgConnectionOpenConfirm
	],
	['/ibc.core.connection.v1.MsgConnectionOpenInit', MsgConnectionOpenInit],
	['/ibc.core.connection.v1.MsgConnectionOpenAck', MsgConnectionOpenAck]
]
export const MissingWalletError = new Error('wallet is required')
const registry = new Registry(types)
const defaultFee = {
	amount: [],
	gas: '200000'
}
const txClient = async (
	wallet,
	{ addr: addr } = { addr: 'http://localhost:26657' }
) => {
	if (!wallet) throw MissingWalletError
	const client = await SigningStargateClient.connectWithSigner(addr, wallet, {
		registry
	})
	const { address } = (await wallet.getAccounts())[0]
	return {
		signAndBroadcast: (msgs, { fee, memo } = { fee: defaultFee, memo: '' }) =>
			client.signAndBroadcast(address, msgs, fee, memo),
		msgConnectionOpenTry: (data) => ({
			typeUrl: '/ibc.core.connection.v1.MsgConnectionOpenTry',
			value: data
		}),
		msgConnectionOpenConfirm: (data) => ({
			typeUrl: '/ibc.core.connection.v1.MsgConnectionOpenConfirm',
			value: data
		}),
		msgConnectionOpenInit: (data) => ({
			typeUrl: '/ibc.core.connection.v1.MsgConnectionOpenInit',
			value: data
		}),
		msgConnectionOpenAck: (data) => ({
			typeUrl: '/ibc.core.connection.v1.MsgConnectionOpenAck',
			value: data
		})
	}
}
const queryClient = async (
	{ addr: addr } = { addr: 'http://localhost:1317' }
) => {
	return new Api({ baseUrl: addr })
}
export { txClient, queryClient }
